#! perl -w

#
# Construire un fichier html et plein de fichiers gif  partir de
# metapost.mp
#

foreach $main (@ARGV) {

$main =~ s/\.mp$//i;

# On cre les images GIF
# BUG :  chaque fois qu'il y a des fontes, a plante.
# C'est normal pour deux raisons :
#  - si j'utilisais prologuse:=2, il ne trouverait pas les fontes.
#  - Comme j'utilise prologues:=0, c'est encore pire...
# L'idal serait de crer un fichier LaTeX pour chaque fichier postscript,
# de lancer later puis dvips dessus et de rcuprer le fichier postscript.

system "TEX=latex mpost $main";
unlink "$main.log";

opendir(DIR,"./") || die "Cannot open ./ directory for reading : $!";
foreach $file (readdir DIR) {
  if ($file =~ m/^$main.[0-9]+$/) {
    
    ## Cration du fichier PS
    symlink "$file", "$file.eps";
    open(TEX,">$file.tex") || die "cannot open $file.tex for writing : $!";
    print TEX '\nonstopmode'                                          ."\n" ;
    print TEX '\documentclass[a4paper,10pt]{article}'                 ."\n" ;
    print TEX '\usepackage[T1]{fontenc}\usepackage[latin1]{inputenc}' ."\n" ;
    print TEX '\usepackage{graphicx,amsmath,amssymb}'                 ."\n" ;
    print TEX '\pagestyle{empty}'                                     ."\n" ;    
    print TEX '\begin{document}'                                      ."\n" ;
    print TEX '\includegraphics{'. "$file.eps" .'}'                   ."\n" ;
    print TEX '\end{document}'                                        ."\n" ;
    close TEX;
    system "latex $file.tex";
    system "dvips -E -f $file.dvi -o $file.ps";
    
    ## Transformation en GIF
    my ($bbx,$bby,$bbw,$bbh);
    open(PS,"$file.ps");
    while (<PS>) {
      if (/^%%BoundingBox:\s+(-?\d+)\s+(-?\d+)\s+(-?\d+)\s+(-?\d+)/) {
        $bbx = 0-$1;    $bby = 0-$2;
        $bbw = $3+$bbx;    $bbh = $4+$bby;
#	print "*** Seen BBOX\n";
      }
      last if /^%%EndComments/;
    }
    close(PS);

    my $scale = 3;
    my $density = 72*$scale;
    $bbw = $scale * $bbw;
    $bbh = $scale * $bbh;
#    print "*** gs -q -dNOPAUSE -dNO_PAUSE -sDEVICE=ppmraw -g${bbw}x${bbh} -r$density -sOutputFile=$file.ppm\n";
    open(GS, "|gs -q -dNOPAUSE -dNO_PAUSE -sDEVICE=ppmraw -g${bbw}x${bbh} -r$density -sOutputFile=$file.ppm");
    print GS "$bbx $bby translate\n";
    print GS "($file.ps) run\n";
    print GS "showpage\n";
    print GS "quit\n";
    close(GS);

    system("pnmcrop $file.ppm | ppmquant 256 | ppmtogif > $file.gif");

    unlink "$file.ppm";
    unlink "$file.tex";
    unlink "$file.ps";
    unlink "$file.eps";
    unlink "$file.dvi";
    unlink "$file.aux";
    unlink "$file.log";
    unlink "$file";
  }
}


# On cre le fichier HTML
open(MP,"$main.mp") || die "cannot open $main.mp for reading: $!";
open(HTML,">$main.html") || die "cannot open $main.html for writing: $!";
select HTML;
print "<HTML><HEAD><TITLE>Metapost : exemples</TITLE></HEAD><BODY>\n";
#print "<H1> Mtapost : exemples </H1>\n";
print "<HR><PRE>\n";
while(<MP>){
  if (m/^\s*beginfig\s*\((.*)\)/) {
    print "</PRE><HR><IMG SRC=\"$main.$1.gif\"><PRE>\n";
    print ;
  } elsif (m/^\s*endfig/) {
    print;
    print "</PRE><PRE>\n";
  } else {
    print;
  }
}
print "</PRE>\n";
print "</BODY></HTML>\n";
close HTML;  

}
